/*
	$Id: SCAppQuitter.java,v 1.3 2002/12/08 16:10:04 phonohawk Exp $
	----------
	
    "NiseRingo" is a clone of "Niseharuna" works on MacOS X.
    Copyright (C) 2001 phonohawk

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
import com.apple.cocoa.foundation.*;
import com.apple.cocoa.application.*;
import java.util.*;

public class SCAppQuitter extends Thread
{
    public SCAppQuitter()
    {
    
    }
    
    public void run()
    {
		int pool = NSAutoreleasePool.push();
		
		// SẴZbVperformClose()B
		Vector sessions = SCFoundation.sharedFoundation().getSessionsList();
		synchronized (sessions)
		{
			final int n_sessions = sessions.size();
			for (int i = 0;i < n_sessions;i++)
			{
				SCSession current = (SCSession)sessions.elementAt(i);
				current.performClose();
			}
		}
		
		// ÑZbV0ɂȂ܂őҋ@
		while (SCFoundation.sharedFoundation().numOfSessions() > 0)
		{
			try
			{
				sleep((long)0.2 * 1000);
			}
			catch (InterruptedException e) {}
		}
		
		// AvP[VI
		NSTimer quit_timer = new NSTimer(
										0.0,
										NSApplication.sharedApplication(),
										new NSSelector("terminate",new Class[] {NSNull.class}),
										new Object[] {NSNull.nullValue()},
										false);
		SCFoundation.sharedFoundation().getRunLoopOfMainThread().addTimerForMode(quit_timer,NSRunLoop.DefaultRunLoopMode);
		
		NSAutoreleasePool.pop(pool);
    }
}
