/*
    "NiseRingo" is a clone of "Niseharuna" works on MacOS X.
    Copyright (C) 2001 phonohawk

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
import java.io.*;
import java.util.*;

public class SCDebugShiori
{
    public SCDebugShiori(File ghost_dir)
    {
    
    }
    
    public static boolean checkIfUsable(File ghost_dir)
    {
        // DEBUGSHIORItrueB
		File[] items = ghost_dir.listFiles();
		if (items == null) return false;
		final int n_items = items.length;
		for (int i = 0;i < n_items;i++)
		{
			if (items[i].getName().equals("DEBUGSHIORI"))
			{
				return true;
			}
		}
		return false;
    }
    
    public void terminate()
    {
    
    }
    
    public static String getModuleName()
    {
        return "DebugSHIORI";
    }
    
    protected int status = 0;
    public String request(String req)
    {
	BufferedReader br = new BufferedReader(new StringReader(req));
	
	// ܂̓wb_ǂ
	String header = null;
	try{ header = br.readLine(); }catch (Exception e){}
	
	// NGXgŜǂ
	Hashtable hash = new Hashtable();
	String line = null;
	while (true)
	{
	    try{ line = br.readLine(); }catch (Exception e){}
	    if (line == null) break;
	    if (line.indexOf(':') == -1) continue;
	    
	    String label = line.substring(0,line.indexOf(':'));
	    String data = line.substring(line.indexOf(':')+2); // R̎̃Xy[X͖
	    
	    hash.put(label,data);
	}
	
	try{ br.close(); }catch(IOException e){}
	
	// ߊJnB
	if (header.startsWith("TEACH"))
	{
	    // 1: 311 Not Enough
	    // 2: 312 Advice
	    // 3: 311 Not Enough
	    // 4: 200 OK
	    status++;
	    
	    SCFoundation.debugstr("Word: "+(String)hash.get("Word"));
	    SCFoundation.debugstr("Ref0: "+(String)hash.get("Reference0"));
	    SCFoundation.debugstr("Ref1: "+(String)hash.get("Reference1"));
	    SCFoundation.debugstr("Ref2: "+(String)hash.get("Reference2"));
	    SCFoundation.debugstr("Ref3: "+(String)hash.get("Reference3"));
	    SCFoundation.debugstr("Ref4: "+(String)hash.get("Reference4"));
	    SCFoundation.debugstr("");
	    
	    switch (status)
	    {
		case 1:
		    return "SHIORI/2.4 311 Not Enough\r\nSentence: 1st. not enough\r\n\r\n";
		
		case 2:
		    return "SHIORI/2.4 312 Advice\r\nSentence: 2nd. advice\r\n\r\n";
		
		case 3:
		    return "SHIORI/2.4 311 Not Enough\r\nSentence: 3rd. not enough\r\n\r\n";
		
		case 4:
		    status = 0;
		    return "SHIORI/2.4 200 OK\r\nSentence: 4th. ok\r\n\r\n";
		    
		default: return "SHIORI/2.0 500 Internal Server Error\r\n\r\n";
	    }
	}
	else
	{
	    return "SHIORI/2.0 500 Internal Server Error\r\n\r\n";
	}
    }
}
