/*  $Id: SCInputBoxController.java,v 1.4 2005/04/28 19:10:28 phonohawk Exp $
	
    "NiseRingo" is a clone of "Niseharuna" works on MacOS X.
    Copyright (C) 2001-2005 phonohawk

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
import com.apple.cocoa.foundation.*;
import com.apple.cocoa.application.*;

public class SCInputBoxController extends NSWindowController {
    NSTextField textfield;
    
    SCInputBoxSession inputbox_session;
    SCSession session;
    
    public SCInputBoxController(SCInputBoxSession inputbox_session) {
	super("InputBox");
	this.inputbox_session = inputbox_session;
	this.session = inputbox_session.getSession();
	
	window();
	window().setTitle("INPUT : "+session.getSelfName());
    }
    
    public void showWindow(Object sender) {
	// \ׂʒuvZB
	// {̃VF̍INPUT{bNX̍킹邪A؂̖ʒu܂ł炵ďCB
	final int screenWidth = (int)NSScreen.mainScreen().frame().width();
	final int shellLeft = (int)session.getShell(0).x();
	final int shellTop = (int)session.getShell(0).height();
	int teachboxLeft = shellLeft;
	int teachboxBottom = shellTop;
	if (teachboxLeft < 0) {
	    teachboxLeft = 0;
	}
	else if (teachboxLeft + window().frame().width() > screenWidth) {
	    teachboxLeft = screenWidth - (int)window().frame().width();
	}
	window().setFrameOrigin(new NSPoint(teachboxLeft,teachboxBottom));
	super.showWindow(sender);
    }
    
    public void show() {
	if (window().isVisible()) return;
	
        //windowCtrl.showWindow(null);
	NSTimer open_timer = new NSTimer(
	    0.0,
	    this,
	    new NSSelector("showWindow",new Class[] {NSNull.class}),
	    new Object[] {NSNull.nullValue()},
	    false);
	SCFoundation
	    .sharedFoundation()
	    .getRunLoopOfMainThread()
	    .addTimerForMode(open_timer, NSRunLoop.DefaultRunLoopMode);
	if (!Thread.currentThread().getName().equals("main")) {
	    while (!window().isVisible()) {} // ҋ@
	}
    }
    
    public void close(Object sender) {
	window().orderOut(sender);
    }
    
    public void send(Object sender) {
	if (textfield.stringValue().length() == 0) return;
	
	inputbox_session.messageFromUser(textfield.stringValue());
    }
}
