/*  $Id: SCPseudoAIDaemon.java,v 1.2 2003/12/24 06:02:13 phonohawk Exp $
    
    "NiseRingo" is a clone of "Niseharuna" works on MacOS X.
    Copyright (C) 2001 phonohawk

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
import com.apple.cocoa.foundation.*;
import com.apple.cocoa.application.*;

/*
  ̃NX͊Ɏg͂Ă܂B
*/

public class SCPseudoAIDaemon extends Thread {
    SCSession session;
    long millisec_interval;
    volatile boolean signal_stop;
    
    public SCPseudoAIDaemon(SCSession s,long interval) {
        // s : 𓮍삳ZbVB
        // interval : ̊ԊuBPʂ̓~bB[Ȃ瓮삵ȂB
        
        // ۂɂ͊Ԋú}30%̏C܂B
        // łȂƑSẴS[XgĂɒB
        
        session = s;
        millisec_interval = interval;
        signal_stop = false;
        
        //setPriority(Thread.MIN_PRIORITY);
    }
    
    public void run() {
	int pool = NSAutoreleasePool.push();
	
        while(!signal_stop) {
            if (millisec_interval == 0) {
		try {
		    sleep(30 * 1000); // KɃX[vB
		}
		catch (InterruptedException e) {
		    //if (signal_stop) {NSAutoreleasePool.pop(pool); return;} // I
		    if (signal_stop) break; // quit
		}
            }
            else {
                try {
                    int signal = 1;
                    if ( (int)Math.round(Math.random() * 2) == 1 ) signal = -1;
                    
                    long interval = millisec_interval + ( signal * (long)Math.round(Math.random() * millisec_interval * (30.0 / 100.0)) );
                    
                    sleep(interval);
                    
                    int inner_pool = NSAutoreleasePool.push();
                    session.doShioriRandomTalk();
		    NSAutoreleasePool.pop(inner_pool);
                }
                catch (InterruptedException e) {
                    if (signal_stop) {NSAutoreleasePool.pop(pool); return;} // I
                }
            }
        }
	
	NSAutoreleasePool.pop(pool);
    }
    
    public void terminate()
    {
        // UAIf[I܂B
        signal_stop = true;
        interrupt();
        while (isAlive()) {}
    }
    
    public void changeInterval(long interval)
    {
        // ԊuύX܂B
        millisec_interval = interval;
        interrupt();
    }
}
