/*  $Id: SCSerikoSeqIntervalEntry.java,v 1.3 2004/02/05 09:29:35 phonohawk Exp $
	
    "NiseRingo" is a clone of "Niseharuna" works on MacOS X.
    Copyright (C) 2001-2004 phonohawk

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

public class SCSerikoSeqIntervalEntry {
    String type;
    int talk_interval; // C^[o^CvtalkłȂꍇ͏0Ă܂B
    int exec_probability = 1; // randomnłȂꍇ͏1Ă܂B
    
    public SCSerikoSeqIntervalEntry(String param) {
	/*
	  param : [id]interal,ȍ~w肵ĉB
	  
	  Ⴆ
	  always
	  runonce
	  talk,[interval]
	  łB
	*/
	if (param.equals("sometimes")) {
	    type = "random";
	    exec_probability = 2;
	}
	else if (param.equals("rarely")) {
	    type = "random";
	    exec_probability = 4;
	}
	else if (param.startsWith("random")) {
	    type = "random";
	    
	    try {
		exec_probability = Integer.parseInt( param.substring(7) );
	    } catch (Exception e) {}
	}
	else if (param.startsWith("talk")) {
	    type = "talk";
	    
	    try {
		talk_interval = Integer.parseInt( param.substring(5) );
	    } catch(Exception e) {}
	}
	else {
	    type = param;
	}
    }
    
    public void dump() {
	System.out.println("Interval : "+type+","+exec_probability);
    }

    public String toString() {
	StringBuffer buf = new StringBuffer();
	buf.append("type: ").append(type);
	buf.append("; probability: ").append(exec_probability);
	return buf.toString();
    }
    
    public String type() {
	return type;
    }
    
    public int talkInterval() {
	// ^CvtalkłȂꍇ͏0Ԃ܂B
	return talk_interval;
    }
    
    public int probability() {
	// ^CvrandomnłȂꍇ͏1Ԃ܂B
	return exec_probability;
    }
}
