/*
    $Id: SCUpdates2Dau.java,v 1.3 2003/07/15 15:03:34 phonohawk Exp $
    ----------
	
    "NiseRingo" is a clone of "Niseharuna" works on MacOS X.
    Copyright (C) 2001 phonohawk

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
import java.util.*;
import java.io.*;

public class SCUpdates2Dau extends SCUpdatesList {
    public SCUpdates2Dau() {
	super();
    }
    
    public SCUpdates2Dau(File daufile) {
	// daufile : updates2.daut@C
	super(daufile);
    }
    
    public void addEntry(String line) {
	// ŝłRuntimeExceptionᢐB
	StringTokenizer st = new StringTokenizer(line,"\u0001");
	String file = st.nextToken();
	String md5 = st.nextToken();
	add(new DauElements(file,md5));
    }
	
    public String toLineOfFile(Object obj) {
	DauElements elem = (DauElements)obj;
	return elem.getFile() + '\u0001' + elem.getMD5() + '\u0001';
    }
    
    public String returnCode() {
	return "\r\n";
    }
    
    public String encodeType() {
	return "SJIS";
    }
}
