/*
    "NiseRingo" is a clone of "Niseharuna" works on MacOS X.
    Copyright (C) 2001 phonohawk

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
package misaka;
import misaka.*;
import java.io.*;
import java.util.*;

public class Ini
{
    Hashtable root; // key : (String)L[ , content : (String)l or (Vector)l̏W
    
    public Ini()
    {
		// ̃IuWFNg쐬B
		root = new Hashtable();
    }
    
    public Ini(File f)
    {
		// t@CǂݍށB
		// ݂Ȃ΋̃IuWFNg쐬B
		root = new Hashtable();
		if (f.exists())
		{
			try{ load(new FileInputStream(f)); }catch(Exception e){}
		}
    }
    
    public Ini(InputStream is)
    {
		// Xg[ǂݍށB
		root = new Hashtable();
		load(is);
    }
    
    public Object get(String key)
    {
		// Ԃ̂StringVector̂ǂ炩łB
		return root.get(key);
    }
    
    private void load(InputStream is)
    {
		try
		{
			BufferedReader br = new BufferedReader(new InputStreamReader(is,"SJIS"));
			while (true)
			{
				String line = br.readLine();
				if (line == null) break; // eof
				if (line.length() == 0) continue; // ̍s͖B
				
				if (line.indexOf(',') != -1) // PsGg
				{
					int commapos = line.indexOf(',');
					String key = line.substring(0,commapos);
					String value = line.substring(commapos+1);
					root.put(key,value);
					continue;
				}
				
				// PsłȂΕsɓnGgȂ̂
				// uX̎n܂肩I܂łǂݍށB
				String entryname = line;
				Vector elements = new Vector();
				
				if (!br.readLine().equals("{")) break; // uXŎn܂ĂȂ΃G[B
				while (true)
				{
					String inner_line = br.readLine();
					if (inner_line == null) break; // ubNIOEOFɒBBG[B
					if (inner_line.length() == 0) continue; // ̍s͖B
					if (inner_line.equals("}")) break; // ubNɏIB
					
					elements.add(inner_line);
				}
				
				root.put(entryname,elements);
			}
			br.close();
		}
		catch (Exception e)
		{
			System.err.println("SCMisakaIni : exception occured in loading ini stream.");
			e.printStackTrace();
		}
    }
}
