/*
    "NiseRingo" is a clone of "Niseharuna" works on MacOS X.
    Copyright (C) 2001 phonohawk

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
import com.apple.cocoa.foundation.*;
import com.apple.cocoa.application.*;

public class SCStatusWindowController extends NSWindowController
{
	public static float WINDOW_WIDTH = 230; // 166
	public static float WINDOW_HEIGHT = 120; // 90
	
    SCStatusWindowCenter center;
    //NSView view_text_type;
    //NSView view_progress_bar_type;
    SCStatusTextView view_text_textview;
    SCStatusProgressBarView view_pbar_view;
    
    Object refcon; // SCStatusWindowCentergp܂B
    
    public SCStatusWindowController(SCStatusWindowCenter center)
    {
		super(new SCStatusWindow(WINDOW_WIDTH,WINDOW_HEIGHT));
		view_text_textview = new SCStatusTextView(window().frame());
		view_pbar_view = new SCStatusProgressBarView(window().frame());
		//super("StatusWindow");
		//window();
		
		this.center = center;
		window().setLevel(NSWindow.FloatingWindowLevel);
    }
    
    public void setRefcon(Object o) {refcon = o;}
    public Object getRefcon() {return refcon;}
    
    public void show()
    {
		if (window().isVisible()) return;
	
        //windowCtrl.showWindow(null);
		NSTimer open_timer = new NSTimer(
				0.0,
				this,
				new NSSelector("showWindow",new Class[] {NSNull.class}),
				new Object[] {NSNull.nullValue()},
				false);
		SCFoundation.sharedFoundation().getRunLoopOfMainThread().addTimerForMode(open_timer,NSRunLoop.DefaultRunLoopMode);
		if (!Thread.currentThread().getName().equals("main")) while (!window().isVisible()) {} // ҋ@
    }
    
    public void closeWindow()
    {
		center.closeStatusWindow(this);
    }
    
    public void setTypeToText()
	{
		//window().setContentView(view_text_type);
		window().setContentView(view_text_textview);
	}
	
    public void setTypeToProgressBar()
	{
		//window().setContentView(view_progress_bar_type);
		window().setContentView(view_pbar_view);
	}
    
    /************** eLXg^Cv *************/
    public void texttype_print(String str)
    {
		view_text_textview.printstr(str);
    }
    public void texttype_println(String str)
    {
		view_text_textview.printstr(str+'\n');
	}
    
    /*********** vOXo[^Cv ***********/
    public void pbartype_setText1(String str)
    {
		view_pbar_view.setText1(str);
    }
    public void pbartype_setText2(String str)
    {
		view_pbar_view.setText2(str);
    }
    public void pbartype_setVal(double val)
    {
		view_pbar_view.setVal(val);
    }
}
