/*
	$Id: SCTeachSession.java,v 1.4 2002/12/08 16:10:07 phonohawk Exp $
	----------
	
    "NiseRingo" is a clone of "Niseharuna" works on MacOS X.
    Copyright (C) 2001 phonohawk

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
import com.apple.cocoa.foundation.*;
import com.apple.cocoa.application.*;
import java.util.*;

/*
	SHIORI/3.0łTEACH͖`̂悤ł̂ŁA
	̃XbhSHIORI/3.0ł͉ɏI܂B
*/

public class SCTeachSession extends Thread
{
    SCSession session;
    protected volatile boolean flagTerm = false;
    
    protected volatile String lastMessageFromUser;
    SCTeachBoxController box;
    
    public SCTeachSession(SCSession session)
    {
		this.session = session;
    }
    
    public void run()
    {
		if (session.getMasterSpirit().getShioriProtocolVersion() != 2) return;
		final int pool = NSAutoreleasePool.push();
		
		// ܂TEACHBOXJB
		box = new SCTeachBoxController(this);
		box.show();
		
		// ReferenceX^bN
		Vector refs = new Vector();
		
		// TEACHBOX̓͂ҋ@邪AflagTermtrueɂȂ狭IB
		String word = null;
		while (!flagTerm)
		{
			while (!flagTerm)
			{
				lastMessageFromUser = null;
				try
				{
					sleep(30 * 1000);
				}
				catch (InterruptedException e)
				{
					if (flagTerm) break;
					if (lastMessageFromUser != null) break; // 30bԓ͂Ă30bԑҋ@
				}
			}
			if (flagTerm) break;
			
			if (word == null) // EChEJĂŏ̓
			{
				word = lastMessageFromUser;
			}
			else
			{
				refs.add(lastMessageFromUser); // ReferenceX^bNɐς
			}
			
			// NGXg쐬
			StringBuffer buf = new StringBuffer("TEACH SHIORI/2.4\r\nSender: "+SCFoundation.STRING_FOR_SENDER+"\r\n");
			buf.append("Word: "+word+"\r\n");
			final int n_refs = refs.size();
			for (int i = 0;i < n_refs;i++)
			{
				buf.append("Reference"+i+": "+(String)refs.elementAt(i)+"\r\n");
			}
			buf.append("\r\n");
			
			// SCSpirit𒼐ڒ@SHIORIƒʐM
			SCShioriSessionResponce resp = session.getMasterSpirit().doShioriSession(buf.toString());
			
			// ɉē쑱s
			String header = resp.getHeader();
			if (header.indexOf("200 OK") != -1)
			{
				// SHIORIɒ点ăZbVB
				session.shioriResponceWork(resp,true);
				break;
			}
			else if (header.indexOf("311 Not Enough") != -1)
			{
				// X^bN͂̂܂܂ɁAĂѓ͑҂
				session.shioriResponceWork(resp,true);
			}
			else if (header.indexOf("312 Advice") != -1)
			{
				// X^bN̍Ō̍ڂ폜āAĂѓ͑҂
				refs.remove(refs.size()-1);
				session.shioriResponceWork(resp,true);
			}
			else
			{
				// SHIORIG[ԂB
				// IB
				break;
			}
		}
		
		box.close();
		NSAutoreleasePool.pop(pool);
    }
    
    public SCSession getSession()
    {
		return session;
    }
    
    public void messageFromUser(String msg)
    {
		// SCTeachBoxController݂̂gp܂B
		// TEACHBOXɃ[U[͂nĉB
		lastMessageFromUser = msg;
		interrupt();
    }
    
    public void terminate()
    {
		// TeachZbVI܂B
		flagTerm = true;
		interrupt();
		if (box != null) box.close();
		
		while (isAlive()) {}
    }
}
