/*  $Id: SCUnixSystemCalls.java,v 1.2 2004/04/08 08:56:26 phonohawk Exp $
    
    "NiseRingo" is a clone of "Niseharuna" works on MacOS X.
    Copyright (C) 2001-2004 phonohawk

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
import com.apple.cocoa.foundation.*;
import com.apple.cocoa.application.*;
import com.apple.cocoa.foundation._private.*;

public class SCUnixSystemCalls {
    /*
	このクラスはObjective-Cで書かれた実際のコードをJavaから呼び出す為のアクセッサです。
    */
    protected static SCUnixSystemCalls_Impl implimentation;
    protected static NSObjectiveCSelector sel_chmod;
    static {
	implimentation = new SCUnixSystemCalls_Impl(); // shared object
	sel_chmod = new NSObjectiveCSelector("chmod:mode:");
    }
    
    public static void chmod(String fpath,int mode) {
	try {
	    sel_chmod.invoke(implimentation,new Object[] {fpath,new Integer(mode)});
	}
	catch (Exception e) {
	    System.err.println("SCUnixSystemCalls : Couldn\'t call the obj-c method chmod:mode:");
	    e.printStackTrace();
	}
    }
}
