/*  $Id: Translator.java,v 1.3 2004/01/29 12:14:45 phonohawk Exp $
    
    "NiseRingo" is a clone of "Niseharuna" works on MacOS X.
    Copyright (C) 2001-2004 phonohawk

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
package satori;
import satori.*;
import java.io.*;
import java.util.*;

public class Translator {
    Hashtable dic;
    
    public Translator(File f) {
	// f : replace.txtt@CB
	// ݂ȂΏȗꂽ̂ƌ􂷁B
	dic = new Hashtable();
		
	if (f.exists()) {
	    try {
		BufferedReader br = new BufferedReader(new InputStreamReader(new FileInputStream(f),"SJIS"));
		while (true) {
		    String line = br.readLine();
		    if (line == null) break; // eof
		    
		    //line = ZenHanTranslator.convZenToHan(line); // SpƋL𔼊pɕςĂ܂
		    
		    int tab_pos = line.indexOf('\t');
		    if (tab_pos == -1) continue;
		    
		    String from = line.substring(0,tab_pos);
		    String to = line.substring(tab_pos+1);
		    dic.put(from,to);
		}
	    }
	    catch (Exception e) {
		System.err.println("Translator : exception occuered while loading "+f.getName());
		e.printStackTrace();
	    }
	}
    }
    
    public String translate(String src) {
	StringBuffer buf = new StringBuffer(src);
	int pos = 0;
	
	while (pos < buf.length()) {
	    boolean replaced = false;
	    
	    for (Enumeration e = dic.keys();e.hasMoreElements();) {
		String before = (String)e.nextElement();
		
		if (buf.toString().startsWith(before,pos)) {
		    String after = (String)dic.get(before);
		    
		    buf.replace(pos,pos+before.length(),after);
		    //pos = pos - before.length() + after.length();
		    pos = pos + after.length();
		    replaced = true;
		    break;
		}
	    }
	    
	    if (!replaced) {
		pos++;
	    }
	}
	return buf.toString();
    }
}
